core/urls.py
from django.contrib import admin
from django.shortcuts import redirect
from django.urls import path, include
from django.conf import settings

urlpatterns = [
    path("", lambda _: redirect('votes:poll-list')),
    path("admin/", admin.site.urls),
    path("votes/", include("votes.urls")),
    path("accounts/", include("django.contrib.auth.urls")),
    path("oauth2/", include('social_django.urls', namespace=settings.SOCIAL_AUTH_URL_NAMESPACE)),
    path("__debug__/", include("debug_toolbar.urls")),
]

votes/urls.py
from django.contrib import admin
from django.contrib.auth.views import LogoutView
from django.urls import path, include
from votes import views

app_name = 'votes'

urlpatterns = [
    path("logout/", LogoutView.as_view(next_page='/'), name='logout'),
    path('poll/', views.PollListView.as_view(), name='poll-list'),
    path('poll/<pk>/change/', views.PollChangeView.as_view(), name='poll-change'),
    path('poll/<pk>/assign/', views.PollAssignView.as_view(), name='poll-assign'),
    path('poll/<pk>/vote/', views.PollVoteView.as_view(), name='poll-vote'),
    path('poll/<pk>/suggest/', views.PollSuggestView.as_view(), name='poll-suggest'),
    path('poll/<pk>/results/', views.PollResultView.as_view(), name='poll-results'),
    path('option/<pk>/change/', views.OptionChangeView.as_view(), name='option-change'),
    path('option/<pk>/delete/', views.OptionDeleteView.as_view(), name='option-delete'),
]

votes/models.py
from django.db import models
from django.db.models import When, Case, Value
from django.db.models.functions import Now
from django.conf import settings
from django.utils.translation import gettext_lazy as _
from model_guard.shortcuts import assign_permissions


class PollQueryset(models.QuerySet):

    def with_open_to_vote(self):
        return self.annotate(
            open_to_vote=Case(
                When(vote_until=None, vote_after=None, then=Value(True)),
                When(vote_after__lte=Now(), vote_until=None, then=Value(True)),
                When(vote_after=None, vote_until__gte=Now(), then=Value(True)),
                When(vote_after__lte=Now(), vote_until__gte=Now(), then=Value(True)),
                default=Value(False),
                output_field=models.BooleanField('open_to_vote'),
            )
        )

    def with_open_to_suggest(self):
        return self.annotate(
            open_to_suggest=Case(
                When(suggest_until=None, suggest_after=None, then=Value(True)),
                When(suggest_after__lte=Now(), suggest_until=None, then=Value(True)),
                When(suggest_after=None, suggest_until__gte=Now(), then=Value(True)),
                When(suggest_after__lte=Now(), suggest_until__gte=Now(), then=Value(True)),
                default=Value(False),
                output_field=models.BooleanField('open_to_suggest'),
            )
        )

    def with_open_to_follow(self):
        return self.annotate(
            open_to_follow=Case(
                When(real_time=True, then=Value(True)),
                When(vote_until__gte=Now(), then=Value(False)),
                When(open_to_vote=True, then=Value(False)),
                default=Value(True),
                output_field=models.BooleanField('open_to_follow'),
            )
        )

    def with_open_to(self):
        return self\
            .with_open_to_suggest() \
            .with_open_to_vote() \
            .with_open_to_follow()


class PollManager(models.Manager.from_queryset(PollQueryset)):

    def get_queryset(self) -> models.QuerySet:
        return super().get_queryset().with_open_to()


class Poll(models.Model):

    objects = PollManager()

    class Meta:
        ordering = [
            'title',
        ]
        permissions = [
            ("poll_vote", "Pode votar"),
            ("poll_suggest", "Pode Sugerir"),
        ]

    active = models.BooleanField(
        default=True,
    )

    author = models.ForeignKey(
        settings.AUTH_USER_MODEL,
        on_delete=models.SET_NULL,
        null=True,
        blank=True,
    )

    title = models.CharField(
        max_length=256,
    )

    description = models.TextField(
        null=True,
        blank=True,
    )

    real_time = models.BooleanField(
        default=False,
    )

    suggest_after = models.DateTimeField(
        null=True,
        default=None,
        blank=True,
    )

    suggest_until = models.DateTimeField(
        null=True,
        default=None,
        blank=True,
    )

    vote_after = models.DateTimeField(
        null=True,
        default=None,
        blank=True,
    )

    vote_until = models.DateTimeField(
        null=True,
        default=None,
        blank=True,
    )

    def __str__(self) -> str:
        return self.title

    def get_sorted_options(self):
        return self.option_set\
            .with_sum_votes_value()\
            .with_count_votes()\
            .order_by('-sum_votes_value')

    assign_permissions = assign_permissions


class OptionQuerySet(models.QuerySet):

    def with_sum_votes_value(self):
        return self.annotate(
            sum_votes_value=models.Sum('vote__value', default=0.)
        )

    def with_count_votes(self):
        return self.annotate(
            count_votes=models.Count('vote__pk')
        )


class Option(models.Model):
    
    objects = OptionQuerySet.as_manager()
    
    class Meta:
        ordering = [
            'title',
        ]

    created_at = models.DateTimeField(
        auto_now_add=True,
    )

    updated_at = models.DateTimeField(
        auto_now=True,
    )

    author = models.ForeignKey(
        settings.AUTH_USER_MODEL,
        on_delete=models.SET_NULL,
        null=True,
        blank=True,
    )

    poll = models.ForeignKey(
        Poll,
        on_delete=models.CASCADE,
    )

    title = models.CharField(
        max_length=256,
    )

    description = models.TextField(
        null=True,
        blank=True,
    )
    
    def can_delete(self):
        return self.poll.open_to_suggest and self.count_votes == 0
    
    def can_change(self):
        return self.poll.open_to_suggest and self.count_votes == 0

    def __str__(self) -> str:
        return self.title


class Vote(models.Model):

    class Meta:
        unique_together = [
            ('author', 'option',)
        ]

    created_at = models.DateTimeField(
        auto_now_add=True,
    )

    updated_at = models.DateTimeField(
        auto_now=True,
    )

    author = models.ForeignKey(
        settings.AUTH_USER_MODEL,
        on_delete=models.CASCADE,
    )

    option = models.ForeignKey(
        Option,
        on_delete=models.CASCADE
    )

    value = models.FloatField(
        default=1.,
    )

votes/views.py
from typing import Any
from django.db.models.base import Model as Model
from django.forms.models import model_to_dict
from django import forms
from django.http import HttpRequest, HttpResponse
from django.shortcuts import redirect
from votes.models import *
from django import forms
from django.contrib.auth.models import Group
from django.forms import ModelForm, Form
from django.shortcuts import resolve_url
from django.views.generic import ListView, UpdateView, DetailView
from django.views.generic.edit import UpdateView, DeleteView
from model_guard.views import ObjectPermissionMixin, ObjectAuthorOrPermissionMixin, ListFilterObjectPermissionMixin


class PollForm(ModelForm):
    class Meta:
        model = Poll
        exclude = ('author',)


class PollChangeView(ObjectPermissionMixin, UpdateView):
    required_permissions = 'change_poll'
    template_name = 'form.html'
    model = Poll
    form_class = PollForm

    def get_success_url(self) -> str:
        return resolve_url('votes:poll-change', pk=self.object.pk)


class PollAssignForm(ModelForm):

    groups = forms.ModelMultipleChoiceField(
        queryset=Group.objects.all(),
    )

    class Meta:
        model = Poll
        fields = []


class PollAssignView(ObjectPermissionMixin, UpdateView):
    required_permissions = 'change_poll'
    template_name = 'form.html'
    model = Poll
    form_class = PollAssignForm

    def get_success_url(self) -> str:
        return resolve_url('votes:poll-list')

    def form_valid(self, form):
        groups = Group.objects.filter(pk__in=form.data['groups'])
        self.object.assign_permissions(
            permissions=('view_poll', 'poll_vote', 'poll_suggest'),
            groups=groups,
        )
        return super().form_valid(form)


class PollResultView(ObjectPermissionMixin, DetailView):
    required_permissions = 'view_poll'
    template_name = 'poll/results.html'
    model = Poll
    queryset = Poll.objects.filter(open_to_follow=True)


class PollListView(ListFilterObjectPermissionMixin, ListView):
    required_permissions = 'view_poll'
    template_name = 'poll/list.html'
    model = Poll
    queryset = Poll.objects.filter(active=True)


class PollSuggestForm(ModelForm):

    class Meta:
        model = Option
        fields = [
            'title',
            'description',
        ]


class PollVoteForm(ModelForm):

    value = forms.FloatField(
        min_value=-1,
        max_value=+1,
        widget=forms.RadioSelect(choices=(
            (-1., '-1'),
            (0., '0'),
            (+1., '+1'),
        )),
        initial=0.,
    )

    class Meta:
        model = Vote
        fields = [
            'value',
        ]

    def save(self, author, option, commit: bool = True) -> Any:
        instance, _ = Vote.objects.update_or_create(
            defaults=self.cleaned_data,
            author=author,
            option=option,
        )
        return instance


class PollSuggestView(ObjectPermissionMixin, UpdateView):
    required_permissions = 'poll_suggest'
    template_name = 'poll/suggest.html'
    model = Poll
    queryset = Poll.objects.filter(open_to_suggest=True)
    form_class = PollSuggestForm

    def get_success_url(self) -> str:
        return resolve_url('votes:poll-suggest', pk=self.object.pk)

    def get_form_kwargs(self) -> dict[str, Any]:
        kwargs = super().get_form_kwargs()
        kwargs['instance'] = None
        return kwargs

    def form_valid(self, form):
        form.instance.poll = self.object
        form.instance.author = self.request.user
        form.save()
        return redirect(self.get_success_url())


class PollVoteView(ObjectPermissionMixin, UpdateView):
    required_permissions = 'poll_vote'
    template_name = 'poll/vote.html'
    model = Poll
    queryset = Poll.objects.filter(open_to_vote=True)
    fields = []

    def get_success_url(self) -> str:
        if self.object.open_to_follow:
            return resolve_url('votes:poll-results', pk=self.object.pk)
        else:
            return resolve_url('votes:poll-list')

    def get_context_data(self, **kwargs: Any) -> dict[str, Any]:
        if 'forms' not in kwargs:
            kwargs['forms'] = self.get_forms()
        return super().get_context_data(**kwargs)

    def form_valid(self, form, option):
        return form.save(author=self.request.user, option=option)

    def get_forms(self, data=None):
        for option in self.object.option_set.all():
            try:
                vote = Vote.objects.get(author=self.request.user, option=option)
            except Vote.DoesNotExist:
                vote = Vote(
                    author=self.request.user,
                    option=option,
                    value=0.,
                )
            yield option, PollVoteForm(
                data,
                prefix=f'option_{option.pk}',
                initial=model_to_dict(vote),
                instance=vote,
            )

    def post(self, request, *args, **kwargs):
        self.object = self.get_object()
        forms = list(self.get_forms(request.POST))
        error = False
        for option, form in forms:
            if form.is_valid():
                self.form_valid(form, option)
            else:
                error = True
        if error:
            return self.render_to_response(self.get_context_data(forms=forms))
        return redirect(self.get_success_url())


class OptionForm(ModelForm):
    class Meta:
        model = Option
        exclude = ('author',)


class OptionChangeView(ObjectAuthorOrPermissionMixin, UpdateView):
    required_permissions = 'change_option'
    template_name = 'form.html'
    model = Option
    form_class = OptionForm
    queryset = Option.objects.filter(
        poll__in=Poll.objects.filter(open_to_suggest=True),
        vote__isnull=True,
    )

    def get_success_url(self) -> str:
        return resolve_url('votes:poll-suggest', pk=self.object.poll.pk)


class OptionDeleteView(ObjectAuthorOrPermissionMixin, DeleteView):
    required_permissions = 'delete_option'
    template_name = 'form.html'
    model = Option
    queryset = Option.objects.filter(
        poll__in=Poll.objects.filter(open_to_suggest=True),
        vote__isnull=True,
    )

    def get_context_data(self, **kwargs) -> dict[str, Any]:
        context = super().get_context_data(**kwargs)
        context["delete"] = True
        return context

    def get_success_url(self) -> str:
        return resolve_url('votes:poll-suggest', pk=self.object.poll.pk)

votes/templates/base.html
<!DOCTYPE html>
<html>
  <head>
    <meta charset="utf-8" />
    <meta name="viewport" content="width=device-width, initial-scale=1" />
    <title>
      {% block title %}
        Votação
      {% endblock %}
    </title>
    <link href="https://cdn.jsdelivr.net/npm/bootstrap@5.3.3/dist/css/bootstrap.min.css" rel="stylesheet" integrity="sha384-QWTKZyjpPEjISv5WaRU9OFeRpok6YctnYmDr5pNlyT2bRjXh0JMhjY6hW+ALEwIH" crossorigin="anonymous" />
    <link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/font-awesome/6.5.1/css/all.min.css" integrity="sha512-DTOQO9RWCH3ppGqcWaEA1BIZOC6xxalwEsw9c2QQeAIftl+Vegovlnee1c9QX4TctnWMn13TZye+giMm8e2LwA==" crossorigin="anonymous" referrerpolicy="no-referrer" />
    <script src="https://cdn.jsdelivr.net/npm/bootstrap@5.3.3/dist/js/bootstrap.bundle.min.js" integrity="sha384-YvpcrYf0tY3lHB60NNkmXc5s9fDVZLESaAA55NDzOxhy9GkcIdslK1eN7N6jIeHz" crossorigin="anonymous"></script>
  </head>
  <body>
    {% block body %}
      <section id="header" class="container">
        {% block header %}
          <nav class="navbar navbar-light bg-light navbar-expand-lg">
            <div class="container-fluid">
              <a class="navbar-brand" href="/">
                <i class="fa-solid fa-house"></i>
                Home
              </a>
              <button class="navbar-toggler" type="button" data-bs-toggle="collapse" data-bs-target="#navbarSupportedContent" aria-controls="navbarSupportedContent" aria-expanded="true" aria-label="Toggle navigation"><span class="navbar-toggler-icon"></span></button>
              <div class="collapse navbar-collapse" id="navbarSupportedContent">
                <ul class="navbar-nav ms-auto mb-2 mb-lg-0">
                  {% if request.user.is_authenticated %}
                    {% if request.user.is_staff %}
                      <li class="nav-item">
                        <a class="nav-link" href="{% url 'admin:index' %}">
                          <i class="fa-solid fa-user-tie"></i>
                          Admin
                        </a>
                      </li>
                    {% endif %}
                    <li class="nav-item">
                      <form action="{% url 'votes:logout' %}" method="POST">
                        {% csrf_token %}
                        <button type="submit" class="nav-link btn btn-button">
                          <i class="fa-solid fa-right-from-bracket"></i>
                          Logout
                        </button>
                      </form>
                    </li>
                  {% else %}
                    <li class="nav-item">
                      <a class="nav-link" href="{% url 'login' %}">
                        <i class="fa-solid fa-right-to-bracket"></i>
                        Login
                      </a>
                    </li>
                  {% endif %}
                </ul>
              </div>
            </div>
          </nav>
        {% endblock %}
      </section>
      <section id="content" class="container">
        {% block content %}

        {% endblock %}
      </section>
      <section id="footer"></section>
    {% endblock %}
  </body>
</html>

votes/templates/form.html
{% extends "base.html" %}
{% load django_bootstrap5 %}
{% block content %}
<div class="row">
  <h1>
    {% if delete %}
    <small class="text-muted">
      Apagar:
    </small>
    {% endif %}
    {{ object.title }}
  </h1>
  <form method="POST" enctype="{{ enctype|default:'application/x-www-form-urlencoded'}}" action="{{ action|default:request.path }}">
    {% csrf_token %}
    {% bootstrap_form form %}
    <div class="btn-group" role="group">
    <a class="btn btn-secondary" href="{{request.META.HTTP_REFERER}}">
      Voltar
      <i class="fa-solid fa-rotate-left"></i>
    </a>
    {% if delete %}
    <button type="submit" class="btn btn-danger">
      Apagar
      <i class="fa-solid fa-trash"></i>
    </button>
    {% else %}
    <button type="submit" class="btn btn-primary">
        Confirmar
        <i class="fa-solid fa-paper-plane"></i>
    </button>
    {% endif %}
    </div>
  </form>
</div>
{% endblock %}